var rightLinks = {
	gEnabled: true,
	gIsLink: null,
	gHasContext: true,
	gDebug: false,
	gPrefs: Components.classes["@mozilla.org/preferences;1"]
		.createInstance(Components.interfaces.nsIPref),
	gBookmark: false,
	gXULNS: "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",
	gVoidHref: /^javascript:(\s|%20)*(|\/\/|void(\s|%20)*((\s|%20)+0|\((\s|%20)*0(\s|%20)*\)))(\s|%20)*;?$/i,
	gShowContextMenuTOut: null,
	gDisabledByTOut: false,
	gLink: null,
	gEvent: {},
	gOrigJSLinksInBg: false,
	init: function() {
		var rl = rightLinks;
		window.removeEventListener("load", rl.init, false);

		window.addEventListener("click", rl.clickHandler, true);
		window.addEventListener("mousedown", rl.mousedownHandler, true);
		rl.setStatus();
		rl.setItemsMode();
		rl.setDebugMode(); // Hide context menu for Linux
		rl.gPrefs.addObserver("rightlinks.", rl, false);

		// Hotkey:
		var p = nsPreferences;
		var keyVal = p.copyUnicharPref("rightlinks.keyValue", "/");
		if(!keyVal)
			return;
		var kIt = document.getElementById("rightLinks-toggleStatus-key");
		kIt.removeAttribute("disabled");
		kIt.setAttribute(/^VK_/.test(keyVal) ? "keycode" : "key", keyVal);
		var mdfs = p.copyUnicharPref("rightlinks.keyModifiers", "control,shift");
		if(mdfs)
			kIt.setAttribute("modifiers", mdfs);
	},
	destroy: function() {
		var rl = rightLinks;
		window.removeEventListener("unload", rl.destroy, false);
		window.removeEventListener("click", rl.clickHandler, true);
		window.removeEventListener("mousedown", rl.mousedownHandler, true);
		rl.setDebugMode(true);
		rl.gPrefs.removeObserver("rightlinks.", rl);
	},
	get tMenu() {
		return document.getElementById("menu_ToolsPopup");
	},
	get cMenu() {
		return this.gBookmark
			? document.getElementById("bookmarks-context-menu") || document.getElementById("placesContext")
			: document.getElementById("contentAreaContextMenu");
	},
	get mi() {
		return document.getElementById("rightLinks-toggleStatus-mi");
	},
	get status() {
		return document.getElementById("rightLinks-toggleStatus-status");
	},
	get tbb() {
		return document.getElementById("rightLinks-toggleStatus-tbutton");
	},
	get isFx3() {
		var info = Components.classes["@mozilla.org/xre/app-info;1"]
			.getService(Components.interfaces.nsIXULAppInfo);
		return info.version.indexOf("3.") == 0;
	},
	disableContextMenu: function(e) {
		rightLinks.cMenu.collapsed = rightLinks.gIsLink; // see rightLinks.mousedownHandler
	},
	alloyContextMenu: function() {
		setTimeout("rightLinks.cMenu.collapsed = false;", 10);
	},
	getLink: function(e) {
		if(e.button != 2 || e.ctrlKey || e.shiftKey || e.altKey || e.metaKey || !this.gEnabled)
			return false;
		var a = e.originalTarget;
		var ann = a.nodeName.toLowerCase();
		var pnId = a.parentNode.id;
		if(a.namespaceURI == this.gXULNS
			&& a.type != "menu"
			&& (
				(/(^|\s+)bookmark-item(\s+|$)/.test(a.className) && (ann == "toolbarbutton" || ann == "menuitem"))
				|| (ann == "menuitem" && (a.hasAttribute("siteURI") || (a.statusText && pnId == "goPopup")))
			)
			&& pnId != "historyUndoPopup"
		) {
			this.gBookmark = true;
			this.gHasContext = pnId != "goPopup";
			return a;
		}
		this.gBookmark = false;
		this.gHasContext = true;
		while(ann != "#document" && ann != "a") {
			a = a.parentNode;
			ann = a.nodeName.toLowerCase();
		}
		var href = a.href;
		if(!href || a.nodeName.toLowerCase() != "a")
			return false;
		return a;
	},
	getHref: function(a) {
		return a.href
			? a.href
			: a.statusText || (a.node && a.node.uri) || a.getAttribute("siteURI") || "";
	},
	getMenupopup: function(mi) {
		if(mi.nodeName == "toolbarbutton")
			return false;
		var mp, ci = mi, nn;
		do {
			ci = ci.parentNode;
			nn = ci.nodeName;
			if(nn == "menupopup")
				mp = ci;
		}
		while(ci && nn != "toolbar" && nn != "#document")
		return mp;
	},
	hideBookmarksPopup: function(it) {
		var mp = rightLinks.getMenupopup(it);
		if(mp && mp.hidePopup) {
			mp.hidePopup();
			var mn = mp.parentNode;
			if(mn && mn.nodeName == "menu")
				mn.removeAttribute("_moz-menuactive");
		}
	},
	stopEvent: function(e) {
		e.preventDefault();
		e.stopPropagation();
		if(this.gDebug)
			setTimeout("rightLinks.cMenu.hidePopup();", 0);
		clearTimeout(this.gShowContextMenuTOut);
	},
	mousedownHandler: function(e) {
		var rl = rightLinks;
		rl.gLink = rightLinks.getLink(e); // define rightLinks.gBookmark and rightLinks.gHasContext
		rl.gIsLink = !!rl.gLink;
		rl.gDisabledByTOut = false;
		if(!rl.gIsLink || !rl.gHasContext)
			return;
		var cmt = nsPreferences.getIntPref("rightlinks.showContextMenuTimeout", 700);
		if(cmt < 0)
			return;
		for(var p in e) // fx 1.5.0.x and 2.0.0.x bug
			rl.gEvent[p] = e[p];
		rl.gShowContextMenuTOut = setTimeout(
			function() {
				var _e = rl.gEvent;
				var isFx3 = rl.isFx3;
				var x = isFx3 ? _e.screenX : _e.clientX; // not needed now (uses only for fx3)...
				var y = isFx3 ? _e.screenY : _e.clientY;
				rl.cMenu.collapsed = false;
				rl.gDisabledByTOut = true;
				rl.showContextMenu(rl.cMenu, _e.originalTarget, x, y);
			},
			cmt
		);
		window.addEventListener( // For mouse gestures
			"mousemove",
			function() {
				clearTimeout(rl.gShowContextMenuTOut);
				window.removeEventListener("mousemove", arguments.callee, false);
			},
			false
		);
		rl.cMenu.addEventListener(
			"popupshowing",
			function() {
				clearTimeout(rl.gShowContextMenuTOut);
				rl.cMenu.removeEventListener("popupshowing", arguments.callee, false);
			},
			false
		);
	},
	clickHandler: function(e) {
		var rl = rightLinks, p = nsPreferences;

		if(rl.gDisabledByTOut)
			return;
		var a = rl.getLink(e);
		if(!a)
			return;
		var href = rl.getHref(a);
		if(!href)
			return;
		rl.gLink = a;
		if(rl.gBookmark && p.getBoolPref("rightlinks.hideBookmarksPopup", true))
			rl.hideBookmarksPopup(a);
		if(/^javascript:/i.test(href)) {
			rl.stopEvent(e);
			if(!rl.gBookmark &&
				rl.gVoidHref.test(href) &&
				(a.getAttribute("onclick") || a.getAttribute("onmousedown") || a.getAttribute("onmouseup"))
			) {
				if(p.getBoolPref("rightlinks.notifyVoidLinksWithHandlers", true))
					rl.notify(rl.getLocalised("title"), rl.getLocalised("clickHandler"));
				var evt = document.createEvent("MouseEvents"); // thanks to Tab Scope!
				evt.initMouseEvent(
					"click", true, false, a.ownerDocument.defaultView, 1,
					e.screenX, e.screenY, e.clientX, e.clientY,
					false, false, false, false,
					0, null
				);
				rl.setJSLinksBackgroundPolicy();
				a.dispatchEvent(evt);
				rl.restoreJSLinksBackgroundPolicy();
				return;
			}
			var loadJSFunc = rl.loadJSLink;
			var loadJS = p.getBoolPref("rightlinks.loadJavaScriptLinks", true);
			if(p.getBoolPref("rightlinks.notifyJavaScriptLinks", true))
				rl.notify(
					rl.getLocalised("title"),
					rl.getLocalised("JavaScriptLink" + (loadJS ? "" : "Click")),
					true,
					loadJS ? null : loadJSFunc
				);
			if(loadJS)
				loadJSFunc();
		}
		else {
			var tbr = getBrowser();
			var flp = p.getIntPref("rightlinks.filesLinksPolicy", 0);
			if(flp > 0) { // 0 - not check, 1 - load in current tab, 2 - none
				var re = p.copyUnicharPref("rightlinks.filesLinksMask",
					"^[^\\?]+\.(zip|rar|7z|gz|tar|iso|cab|exe|msi|xpi|jar)$");
				if(re) {
					try {
						var _re = new RegExp(re, "i");
						if(_re.test(href)) {
							if(flp == 1) {
								rl.stopEvent(e);
								tbr.loadURI(href, rl.getReferer());
							}
							return;
						}
					}
					catch(e) {
						var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
							.getService(Components.interfaces.nsIPromptService);
						prompts.alert(
							window,
							rl.getLocalised("RegExpErrorTitle"),
							rl.getLocalised("RegExpError").replace("%RegExp", re) + e
						);
					}
				}
			}
			rl.stopEvent(e);

			if("Highlander" in window) { // https://addons.mozilla.org/firefox/addon/4086
				var tab = Highlander.findTabForURI(makeURI(href));
				if(tab) {
					Highlander.selectTab(tab);
					return;
				}
			}

			// Open a new tab as a child of the current tab (Tree Style Tab)
			// http://piro.sakura.ne.jp/xul/_treestyletab.html.en#api
			if(!rl.gBookmark && "TreeStyleTabService" in window)
				TreeStyleTabService.readyToOpenChildTab(gBrowser.selectedTab);

			tbr.loadOneTab(
				href,
				rl.getReferer(),
				null,
				null,
				p.getBoolPref("rightlinks.loadInBackground", true),
				false
			);
		}
	},
	loadJSLink: function() {
		var rl = rightLinks, p = nsPreferences;

		var disId = "dom.disable_open_during_load";
		var dis = p.getBoolPref(disId, true);
		p.setBoolPref(disId, false); // allow window.open( ... )
		rl.setJSLinksBackgroundPolicy();

		var a = rl.gLink;
		var href = rl.getHref(a);
		if(rl.gBookmark)
			getBrowser().loadURI(href); // bookmarklets
		else
			a.ownerDocument.location.href = href; // frames?

		rl.restoreJSLinksBackgroundPolicy();
		if(rl.isFx3) // Bug? And dispatchEvent does not work also (fx block new window)...
			setTimeout(function() { p.setBoolPref(disId, dis); }, 0);
		else
			p.setBoolPref(disId, dis);
	},
	setJSLinksBackgroundPolicy: function() {
		var p = nsPreferences;
		var bgId = "browser.tabs.loadDivertedInBackground";
		this.gOrigJSLinksInBg = p.getBoolPref(bgId, false);
		p.setBoolPref(bgId, p.getBoolPref("rightlinks.loadJavaScriptLinksInBackground", false));
	},
	restoreJSLinksBackgroundPolicy: function() {
		var origBg = this.gOrigJSLinksInBg;
		setTimeout( // For fx 3.0+
			function() {
				nsPreferences.setBoolPref("browser.tabs.loadDivertedInBackground", origBg);
			},
			0
		);
	},
	getReferer: function() { // this.gLink.ownerDocument.documentURIObject
		return !this.gBookmark && nsPreferences.getBoolPref("rightlinks.sendReferer", true)
			? makeURI(this.gLink.ownerDocument.location.href) // see chrome://global/content/contentAreaUtils.js
			: null;
	},
	showContextMenu: function(popup, node, x, y) {
		// http://www.mail-archive.com/project_owners@mozdev.org/msg03291.html
		// .showPopup() return error in 2.0.0.x (cant get document.popupRangeParent)
		// and buggy in 1.5.0.12
		if(!this.isFx3) {
			this.blinkNode();
			return;
		}
		document.popupNode = node;
		popup.showPopup(node, x, y, "popup", null, null);
	},
	blinkNode: function() {
		var node = this.gLink;
		if(!node)
			return;
		var hasStl = node.hasAttribute("style");
		var origVis = node.style.visibility;
		node.style.visibility = "hidden";
		setTimeout(
			function() {
				node.style.visibility = origVis;
				if(!hasStl)
					node.removeAttribute("style");
			},
			170
		);
	},
	toggleStatus: function(notify) {
		this.gEnabled = !this.gEnabled;
		nsPreferences.setBoolPref("rightlinks.enabled", this.gEnabled);
		this.setStatus(this.gEnabled);
		if(notify && this.status.hidden && !this.tbb)
			this.notify(
				this.getLocalised("title"),
				this.getLocalised(this.gEnabled ? "enabled" : "disabled"),
				this.gEnabled
			);
	},
	setStatus: function(enabled) {
		enabled = typeof enabled == "boolean"
			? enabled
			: nsPreferences.getBoolPref("rightlinks.enabled", true);
		this.gEnabled = enabled;
		var st = this.status;
		st.setAttribute("status", enabled ? "enabled" : "disabled");
		var tt = this.getLocalised("title") + " " + this.getLocalised(enabled ? "enabled" : "disabled");
		st.tooltipText = tt;
		this.mi.setAttribute("checked", enabled);
		var tbb = this.tbb;
		if(tbb) {
			tbb.setAttribute("status", enabled ? "enabled" : "disabled");
			tbb.tooltipText = tt;
			tbb.setAttribute("checked", enabled);
			setTimeout(function() { tbb.setAttribute("checked", enabled); }, 0);
		}
	},
	setItemsMode: function() {
		var him = nsPreferences.getIntPref("rightlinks.hideItemsMode", 0);
		this.mi.hidden = him == 1 || him == 2;
		this.status.hidden = him == 1 || him == 3;
	},
	setDebugMode: function(destroy) {
		if(this.gDebug) {
			window.removeEventListener("mousedown", this.disableContextMenu, true);
			window.removeEventListener("mouseup", this.alloyContextMenu, true);
		}
		if(!destroy) {
			this.gDebug = nsPreferences.getBoolPref("rightlinks.debug", false);
			if(this.gDebug) {
				window.addEventListener("mousedown", this.disableContextMenu, true);
				window.addEventListener("mouseup", this.alloyContextMenu, true);
			}
		}
	},
	notify: function(ttl, txt, imgMode, fnc) {
		var dur = nsPreferences.getIntPref("rightlinks.notifyOpenTime", 3000);
		if(dur < 0)
			 return;
		imgMode = typeof imgMode == "boolean" ? imgMode : true;
		window.openDialog(
			 "chrome://rightlinks/content/notify.xul",
			 "",
			 "chrome,dialog=1,titlebar=0,popup=1",
			 dur, ttl, txt, imgMode, fnc
		);
	},
	observe: function(subject, topic, prefName) { // prefs observer
		if(topic != "nsPref:changed") // ???
			return;
		switch(prefName.replace(/^rightlinks\./, "")) {
			case "enabled":       this.setStatus();    break;
			case "hideItemsMode": this.setItemsMode(); break;
			case "debug":         this.setDebugMode();
		}
	},
	getLocalised: function(id) {
		return document.getElementById("rightLinks-strings").getString(id);
	}
};
window.addEventListener("load", rightLinks.init, false);
window.addEventListener("unload", rightLinks.destroy, false);